Index: trunk/sources/HeuristicLab.Problems.DataAnalysis.Views/3.3/SupportVectorRegressionSolutionView.Designer.cs
===================================================================
--- trunk/sources/HeuristicLab.Problems.DataAnalysis.Views/3.3/SupportVectorRegressionSolutionView.Designer.cs	(revision 3883)
+++ trunk/sources/HeuristicLab.Problems.DataAnalysis.Views/3.3/SupportVectorRegressionSolutionView.Designer.cs	(revision 3884)
@@ -44,80 +44,8 @@
     /// </summary>
     private void InitializeComponent() {
-      this.modelTabControl = new System.Windows.Forms.TabControl();
-      this.modelTabPage = new System.Windows.Forms.TabPage();
-      this.modelPanel = new HeuristicLab.MainForm.WindowsForms.ViewHost();
-      this.dataTabPage = new System.Windows.Forms.TabPage();
-      this.dataPanel = new HeuristicLab.MainForm.WindowsForms.ViewHost();
       this.supportVectorTabControl = new System.Windows.Forms.TabPage();
       this.supportVectorViewHost = new HeuristicLab.MainForm.WindowsForms.ViewHost();
-      this.modelTabControl.SuspendLayout();
-      this.modelTabPage.SuspendLayout();
-      this.dataTabPage.SuspendLayout();
       this.supportVectorTabControl.SuspendLayout();
       this.SuspendLayout();
-      // 
-      // modelTabControl
-      // 
-      this.modelTabControl.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
-                  | System.Windows.Forms.AnchorStyles.Left)
-                  | System.Windows.Forms.AnchorStyles.Right)));
-      this.modelTabControl.Controls.Add(this.modelTabPage);
-      this.modelTabControl.Controls.Add(this.dataTabPage);
-      this.modelTabControl.Controls.Add(this.supportVectorTabControl);
-      this.modelTabControl.Location = new System.Drawing.Point(3, 3);
-      this.modelTabControl.Name = "modelTabControl";
-      this.modelTabControl.SelectedIndex = 0;
-      this.modelTabControl.Size = new System.Drawing.Size(247, 245);
-      this.modelTabControl.TabIndex = 0;
-      // 
-      // modelTabPage
-      // 
-      this.modelTabPage.Controls.Add(this.modelPanel);
-      this.modelTabPage.Location = new System.Drawing.Point(4, 22);
-      this.modelTabPage.Name = "modelTabPage";
-      this.modelTabPage.Padding = new System.Windows.Forms.Padding(3);
-      this.modelTabPage.Size = new System.Drawing.Size(239, 219);
-      this.modelTabPage.TabIndex = 0;
-      this.modelTabPage.Text = "Model";
-      this.modelTabPage.UseVisualStyleBackColor = true;
-      // 
-      // modelPanel
-      // 
-      this.modelPanel.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
-                  | System.Windows.Forms.AnchorStyles.Left)
-                  | System.Windows.Forms.AnchorStyles.Right)));
-      this.modelPanel.Caption = "View";
-      this.modelPanel.Content = null;
-      this.modelPanel.Location = new System.Drawing.Point(6, 6);
-      this.modelPanel.Name = "modelPanel";
-      this.modelPanel.ReadOnly = false;
-      this.modelPanel.Size = new System.Drawing.Size(227, 207);
-      this.modelPanel.TabIndex = 0;
-      this.modelPanel.ViewType = null;
-      // 
-      // dataTabPage
-      // 
-      this.dataTabPage.Controls.Add(this.dataPanel);
-      this.dataTabPage.Location = new System.Drawing.Point(4, 22);
-      this.dataTabPage.Name = "dataTabPage";
-      this.dataTabPage.Padding = new System.Windows.Forms.Padding(3);
-      this.dataTabPage.Size = new System.Drawing.Size(239, 219);
-      this.dataTabPage.TabIndex = 1;
-      this.dataTabPage.Text = "Data";
-      this.dataTabPage.UseVisualStyleBackColor = true;
-      // 
-      // dataPanel
-      // 
-      this.dataPanel.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
-                  | System.Windows.Forms.AnchorStyles.Left)
-                  | System.Windows.Forms.AnchorStyles.Right)));
-      this.dataPanel.Caption = "View";
-      this.dataPanel.Content = null;
-      this.dataPanel.Location = new System.Drawing.Point(6, 6);
-      this.dataPanel.Name = "dataPanel";
-      this.dataPanel.ReadOnly = false;
-      this.dataPanel.Size = new System.Drawing.Size(227, 207);
-      this.dataPanel.TabIndex = 0;
-      this.dataPanel.ViewType = null;
       // 
       // supportVectorTabControl
@@ -151,10 +79,6 @@
       this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
       this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
-      this.Controls.Add(this.modelTabControl);
       this.Name = "SupportVectorRegressionSolutionView";
-      this.Size = new System.Drawing.Size(253, 251);
-      this.modelTabControl.ResumeLayout(false);
-      this.modelTabPage.ResumeLayout(false);
-      this.dataTabPage.ResumeLayout(false);
+      this.tabControl.TabPages.Add(supportVectorTabControl);
       this.supportVectorTabControl.ResumeLayout(false);
       this.ResumeLayout(false);
@@ -164,13 +88,6 @@
     #endregion
 
-    private System.Windows.Forms.TabControl modelTabControl;
-    private System.Windows.Forms.TabPage modelTabPage;
-    private HeuristicLab.MainForm.WindowsForms.ViewHost modelPanel;
-    private System.Windows.Forms.TabPage dataTabPage;
-    private HeuristicLab.MainForm.WindowsForms.ViewHost dataPanel;
     private System.Windows.Forms.TabPage supportVectorTabControl;
     private HeuristicLab.MainForm.WindowsForms.ViewHost supportVectorViewHost;
-
-
   }
 }
Index: trunk/sources/HeuristicLab.Problems.DataAnalysis.Views/3.3/SupportVectorRegressionSolutionView.cs
===================================================================
--- trunk/sources/HeuristicLab.Problems.DataAnalysis.Views/3.3/SupportVectorRegressionSolutionView.cs	(revision 3883)
+++ trunk/sources/HeuristicLab.Problems.DataAnalysis.Views/3.3/SupportVectorRegressionSolutionView.cs	(revision 3884)
@@ -40,11 +40,9 @@
   [View("Support Vector Regression Solution View")]
   [Content(typeof(SupportVectorRegressionSolution))]
-  public partial class SupportVectorRegressionSolutionView : AsynchronousContentView {
+  public partial class SupportVectorRegressionSolutionView : DataAnalysisSolutionView {
 
     public new SupportVectorRegressionSolution Content {
       get { return (SupportVectorRegressionSolution)base.Content; }
-      set {
-        base.Content = value;
-      }
+      set { base.Content = value; }
     }
 
@@ -57,25 +55,9 @@
       base.OnContentChanged();
       if (Content != null) {
-        dataPanel.Content = Content.ProblemData;
-        modelPanel.Content = Content.Model;
         supportVectorViewHost.Content = Content.SupportVectors;
       } else {
-        dataPanel.Content = null;
-        modelPanel.Content = null;
         supportVectorViewHost.Content = null;
       }
     }
-    protected override void RegisterContentEvents() {
-      base.RegisterContentEvents();
-      Content.ProblemDataChanged += new EventHandler(Content_ProblemDataChanged);
-    }
-
-    protected override void DeregisterContentEvents() {
-      base.DeregisterContentEvents();
-    }
-
-    private void Content_ProblemDataChanged(object sender, EventArgs e) {
-      dataPanel.Content = Content.ProblemData;
-    }
   }
 }
Index: trunk/sources/HeuristicLab.Problems.DataAnalysis.Views/3.3/Symbolic/SimplifiedSymbolicExpressionModelView.cs
===================================================================
--- trunk/sources/HeuristicLab.Problems.DataAnalysis.Views/3.3/Symbolic/SimplifiedSymbolicExpressionModelView.cs	(revision 3883)
+++ trunk/sources/HeuristicLab.Problems.DataAnalysis.Views/3.3/Symbolic/SimplifiedSymbolicExpressionModelView.cs	(revision 3884)
@@ -39,12 +39,6 @@
 namespace HeuristicLab.Problems.DataAnalysis.Views.Symbolic {
   [View("Simplified Symbolic Expression Model View")]
-  [Content(typeof(SymbolicRegressionSolution))]
+  [Content(typeof(SymbolicRegressionModel))]
   public partial class SimplifiedSymbolicExpressionModelView : AsynchronousContentView {
-    public new SymbolicRegressionSolution Content {
-      get { return (SymbolicRegressionSolution)base.Content; }
-      set { base.Content = value; }
-    }
-
-
     public SimplifiedSymbolicExpressionModelView()
       : base() {
@@ -52,26 +46,20 @@
     }
 
-    protected override void RegisterContentEvents() {
-      base.RegisterContentEvents();
-      Content.ModelChanged += new EventHandler(Content_ModelChanged);
-    }
-
-    protected override void DeregisterContentEvents() {
-      base.DeregisterContentEvents();
-      Content.ModelChanged -= new EventHandler(Content_ModelChanged);
-    }
-
-    void Content_ModelChanged(object sender, EventArgs e) {
-      UpdateTreeChart();
+    public new SymbolicRegressionModel Content {
+      get { return (SymbolicRegressionModel)base.Content; }
+      set { base.Content = value; }
     }
 
     protected override void OnContentChanged() {
       base.OnContentChanged();
-      UpdateTreeChart();
+      if (Content != null)
+        UpdateTreeChart();
+      else
+        viewHost.Content = null;
     }
 
     private void UpdateTreeChart() {
       var simplifier = new SymbolicSimplifier();
-      var simplifiedTree = simplifier.Simplify(Content.Model.SymbolicExpressionTree);
+      var simplifiedTree = simplifier.Simplify(Content.SymbolicExpressionTree);
       viewHost.Content = simplifiedTree;
     }
Index: trunk/sources/HeuristicLab.Problems.DataAnalysis.Views/3.3/Symbolic/SymbolicExpressionModelView.cs
===================================================================
--- trunk/sources/HeuristicLab.Problems.DataAnalysis.Views/3.3/Symbolic/SymbolicExpressionModelView.cs	(revision 3883)
+++ trunk/sources/HeuristicLab.Problems.DataAnalysis.Views/3.3/Symbolic/SymbolicExpressionModelView.cs	(revision 3884)
@@ -39,11 +39,6 @@
 namespace HeuristicLab.Problems.DataAnalysis.Views.Symbolic {
   [View("Symbolic Expression Model View")]
-  [Content(typeof(SymbolicRegressionSolution))]
+  [Content(typeof(SymbolicRegressionModel),true)]
   public partial class SymbolicExpressionModelView : AsynchronousContentView {
-    public new SymbolicRegressionSolution Content {
-      get { return (SymbolicRegressionSolution)base.Content; }
-      set { base.Content = value; }
-    }
-
     public SymbolicExpressionModelView()
       : base() {
@@ -51,25 +46,19 @@
     }
 
-    protected override void RegisterContentEvents() {
-      base.RegisterContentEvents();
-      Content.ModelChanged += new EventHandler(Content_ModelChanged);
-    }
-
-    protected override void DeregisterContentEvents() {
-      base.DeregisterContentEvents();
-      Content.ModelChanged -= new EventHandler(Content_ModelChanged);
-    }
-
-    void Content_ModelChanged(object sender, EventArgs e) {
-      UpdateTreeChart();
+    public new SymbolicRegressionModel Content {
+      get { return (SymbolicRegressionModel)base.Content; }
+      set { base.Content = value; }
     }
 
     protected override void OnContentChanged() {
       base.OnContentChanged();
-      UpdateTreeChart();
+      if (Content != null)
+        UpdateTreeChart();
+      else
+        viewHost.Content = null;
     }
 
     private void UpdateTreeChart() {
-      viewHost.Content = Content.Model.SymbolicExpressionTree;
+      viewHost.Content = Content.SymbolicExpressionTree;
     }
   }
Index: trunk/sources/HeuristicLab.Problems.DataAnalysis/3.3/DataAnalysisProblem.cs
===================================================================
--- trunk/sources/HeuristicLab.Problems.DataAnalysis/3.3/DataAnalysisProblem.cs	(revision 3883)
+++ trunk/sources/HeuristicLab.Problems.DataAnalysis/3.3/DataAnalysisProblem.cs	(revision 3884)
@@ -71,5 +71,7 @@
 
     #region events
-    protected virtual void OnDataAnalysisProblemChanged(EventArgs e) { }
+    protected virtual void OnDataAnalysisProblemChanged(EventArgs e) {
+      RaiseReset(e);
+    }
 
     private void RegisterParameterEvents() {
Index: trunk/sources/HeuristicLab.Problems.DataAnalysis/3.3/DataAnalysisSolution.cs
===================================================================
--- trunk/sources/HeuristicLab.Problems.DataAnalysis/3.3/DataAnalysisSolution.cs	(revision 3883)
+++ trunk/sources/HeuristicLab.Problems.DataAnalysis/3.3/DataAnalysisSolution.cs	(revision 3884)
@@ -36,4 +36,22 @@
   [StorableClass]
   public abstract class DataAnalysisSolution : NamedItem {
+    protected DataAnalysisSolution()
+      : base() { }
+    protected DataAnalysisSolution(DataAnalysisProblemData problemData) : this(problemData, double.NegativeInfinity, double.PositiveInfinity) { }
+    protected DataAnalysisSolution(DataAnalysisProblemData problemData, double lowerEstimationLimit, double upperEstimationLimit)
+      : this() {
+      this.problemData = problemData;
+      this.lowerEstimationLimit = lowerEstimationLimit;
+      this.upperEstimationLimit = upperEstimationLimit;
+      Initialize();
+    }
+
+    [StorableConstructor]
+    private DataAnalysisSolution(bool deserializing) : base(deserializing) { }
+    [StorableHook(HookType.AfterDeserialization)]
+    private void Initialize() {
+      if (problemData != null) RegisterProblemDataEvents();
+    }
+
     [Storable]
     private DataAnalysisProblemData problemData;
@@ -43,11 +61,29 @@
         if (problemData != value) {
           if (value == null) throw new ArgumentNullException();
+          if (model != null && problemData != null && !problemData.InputVariables.Select(c => c.Value).SequenceEqual(
+            value.InputVariables.Select(c => c.Value)))
+            throw new ArgumentException("Could not set new problem data with different structure");
+
           if (problemData != null) DeregisterProblemDataEvents();
           problemData = value;
           RegisterProblemDataEvents();
-          OnProblemDataChanged(EventArgs.Empty);
+          OnProblemDataChanged();
         }
       }
     }
+
+    [Storable]
+    private IDataAnalysisModel model;
+    public IDataAnalysisModel Model {
+      get { return model; }
+      set {
+        if (model != value) {
+          if (value == null) throw new ArgumentNullException();
+          model = value;
+          OnModelChanged();
+        }
+      }
+    }
+
     [Storable]
     private double lowerEstimationLimit;
@@ -57,5 +93,5 @@
         if (lowerEstimationLimit != value) {
           lowerEstimationLimit = value;
-          OnEstimatedValuesChanged(EventArgs.Empty);
+          RecalculateEstimatedValues();
         }
       }
@@ -69,5 +105,5 @@
         if (upperEstimationLimit != value) {
           upperEstimationLimit = value;
-          OnEstimatedValuesChanged(EventArgs.Empty);
+          RecalculateEstimatedValues();
         }
       }
@@ -77,35 +113,5 @@
     public abstract IEnumerable<double> EstimatedTrainingValues { get; }
     public abstract IEnumerable<double> EstimatedTestValues { get; }
-
-    protected DataAnalysisSolution() : base() {
-      Name = ItemName;
-      Description = ItemDescription;
-    }
-    protected DataAnalysisSolution(DataAnalysisProblemData problemData) : this(problemData, double.NegativeInfinity, double.PositiveInfinity) { }
-    protected DataAnalysisSolution(DataAnalysisProblemData problemData, double lowerEstimationLimit, double upperEstimationLimit)
-      : this() {
-      this.problemData = problemData;
-      this.lowerEstimationLimit = lowerEstimationLimit;
-      this.upperEstimationLimit = upperEstimationLimit;
-      Initialize();
-    }
-
-    [StorableConstructor]
-    private DataAnalysisSolution(bool deserializing) : base(deserializing) { }
-
-    [StorableHook(HookType.AfterDeserialization)]
-    private void Initialize() {
-      if (problemData != null) RegisterProblemDataEvents();
-    }
-
-    public override IDeepCloneable Clone(Cloner cloner) {
-      DataAnalysisSolution clone = (DataAnalysisSolution)base.Clone(cloner);
-      // don't clone the problem data!
-      clone.problemData = problemData;
-      clone.lowerEstimationLimit = lowerEstimationLimit;
-      clone.upperEstimationLimit = upperEstimationLimit;
-      clone.Initialize();
-      return clone;
-    }
+    protected abstract void RecalculateEstimatedValues();
 
     #region Events
@@ -116,23 +122,42 @@
       ProblemData.ProblemDataChanged += new EventHandler(ProblemData_Changed);
     }
-
     private void ProblemData_Changed(object sender, EventArgs e) {
-      OnProblemDataChanged(EventArgs.Empty);
+      OnProblemDataChanged();
     }
 
     public event EventHandler ProblemDataChanged;
-    protected virtual void OnProblemDataChanged(EventArgs e) {
+    protected virtual void OnProblemDataChanged() {
+      RecalculateEstimatedValues();
       var listeners = ProblemDataChanged;
       if (listeners != null)
-        listeners(this, e);
+        listeners(this, EventArgs.Empty);
+    }
+
+    public event EventHandler ModelChanged;
+    protected virtual void OnModelChanged() {
+      RecalculateEstimatedValues();
+      EventHandler handler = ModelChanged;
+      if (handler != null)
+        handler(this, EventArgs.Empty);
     }
 
     public event EventHandler EstimatedValuesChanged;
-    protected virtual void OnEstimatedValuesChanged(EventArgs e) {
+    protected virtual void OnEstimatedValuesChanged() {
       var listeners = EstimatedValuesChanged;
       if (listeners != null)
-        listeners(this, e);
+        listeners(this, EventArgs.Empty);
     }
     #endregion
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      DataAnalysisSolution clone = (DataAnalysisSolution)base.Clone(cloner);
+      // don't clone the problem data!
+      clone.problemData = problemData;
+      clone.Model = (IDataAnalysisModel)cloner.Clone(model);
+      clone.lowerEstimationLimit = lowerEstimationLimit;
+      clone.upperEstimationLimit = upperEstimationLimit;
+      clone.Initialize();
+      return clone;
+    }
   }
 }
Index: trunk/sources/HeuristicLab.Problems.DataAnalysis/3.3/HeuristicLab.Problems.DataAnalysis-3.3.csproj
===================================================================
--- trunk/sources/HeuristicLab.Problems.DataAnalysis/3.3/HeuristicLab.Problems.DataAnalysis-3.3.csproj	(revision 3883)
+++ trunk/sources/HeuristicLab.Problems.DataAnalysis/3.3/HeuristicLab.Problems.DataAnalysis-3.3.csproj	(revision 3884)
@@ -98,7 +98,9 @@
     <Compile Include="Evaluators\SimpleVarianceAccountedForEvaluator.cs" />
     <Compile Include="HeuristicLabProblemsDataAnalysisPlugin.cs" />
+    <Compile Include="Interfaces\IDataAnalysisModel.cs" />
     <Compile Include="Interfaces\IDataAnalysisProblem.cs" />
     <Compile Include="MatrixExtensions.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
+    <Compile Include="SupportVectorMachine\ParameterAdjustmentProblem\SupportVectorRegressionParameterAdjustmentBestSolutionAnalyzer.cs" />
     <Compile Include="SupportVectorMachine\ParameterAdjustmentProblem\SupportVectorRegressionParameterAdjustmentEvaluator.cs" />
     <Compile Include="SupportVectorMachine\ParameterAdjustmentProblem\SupportVectorRegressionParameterAdjustmentProblem.cs" />
Index: trunk/sources/HeuristicLab.Problems.DataAnalysis/3.3/Interfaces/IDataAnalysisModel.cs
===================================================================
--- trunk/sources/HeuristicLab.Problems.DataAnalysis/3.3/Interfaces/IDataAnalysisModel.cs	(revision 3884)
+++ trunk/sources/HeuristicLab.Problems.DataAnalysis/3.3/Interfaces/IDataAnalysisModel.cs	(revision 3884)
@@ -0,0 +1,32 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Core;
+
+namespace HeuristicLab.Problems.DataAnalysis {
+  public interface IDataAnalysisModel : INamedItem {
+    IEnumerable<double> GetEstimatedValues(DataAnalysisProblemData problemData, int start, int end);
+  }
+}
